/*****************************
* Source : test.prg
* System : <unkown>
* Author : Phil Ide
* Created: 27/01/2004
*
* Purpose:
* ----------------------------
* History:
* ----------------------------
*    27/01/2004 14:45 PPI - Created
*****************************/

#include "Common.ch"

#define HRTEST_COUNT 10
#define BIT_MASK     0x20
#define TEST_COUNT   16
#define MANTISSA     8
#define REAL         30

proc main()
/*
   local oHR := HRTimer():new():start()
   local nPrecision := oHR:precision()
   local nTicks := Seconds() * nPrecision
   
   ? Str( nTicks, REAL, MANTISSA )
*/
   main2()
   return




procedure main2( n, nSkip, nDo )
   local cString := Memoread('test.prg')
   local cString2
   local i, v
   local o := HRTimer():new()
   local aRet := {} // {{1,0,},{2,0,},{3,0,},{4,0,},{5,0,},{6,0,}}
   local aTest
   local x
   local z

   default n to '4', nSkip to '0',;
           nDo to '-1'

   for i := 1 to TEST_COUNT
      aadd( aRet, {i+0,0,NIL} )
   next

   n := Val(n)
   nSkip := Val(nSkip)
   v := n
   nDo := Val(nDo)
   if nDo < 1
      nDo := TEST_COUNT - nSkip
   endif

   sleep(10)

   While n > 0

      x := 1
      z := 0
      n--
      ?
      ? '[cycle:'+LTrim(Str((v-n)))+']'

      if nSkip < 1
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc0( cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc0( cString2 )  Stuff/SubStr'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 2
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc0( @cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc0( @cString2 ) Stuff/SubStr'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 3
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc0a( cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc0a( cString2 ) @Stuff/SubStr'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif


      if nSkip < 4
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc0a( @cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc0a( @cString2 ) @Stuff/SubStr'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 5
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc1( cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc1( cString2 )   Len(cString)'
         z++
         sleep(1)
      endif


      if z == nDo
         LOOP
      endif

      if nSkip < 6
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc1( @cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc1( @cString2 )  Len(cString)'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 7
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc2( cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc2( cString2 )  asserted length'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 8
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc2( @cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc2( @cString2 ) asserted length'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 9
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc3( cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc3( cString2 )  asserted length, bit-toggle 1'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 10
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc3( @cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc3( @cString2 ) asserted length, bit-toggle 1'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 11
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc4( cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc4( cString2 )  asserted length, bit-toggle 2'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 12
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc4( @cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc4( @cString2 ) asserted length, bit-toggle 2'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 13
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc5( cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc5( cString2 )  bit-toggle using bit-test/upper'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 14
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc5( @cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc5( @cString2 ) bit-toggle using bit-test/upper'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 15
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc6( cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc6( cString2 )  bit-toggle using IsUpper()'
         z++
         sleep(1)
      endif

      if z == nDo
         LOOP
      endif

      if nSkip < 16
         cString2 := cString+''
         o:start()
         for i := 1 to HRTEST_COUNT
            TestFunc6( @cString2 )
         next
         o:stop()
         ? 'Duration:', Str( o:duration, REAL, MANTISSA )
         aRet[x][2] += o:duration
         aRet[x++][3] := 'TestFunc6( @cString2 ) bit-toggle using IsUpper()'
         z++
         sleep(1)
      endif

   Enddo


   x := AScan(aRet,{|e| e[2] == 0 })
   if x > 1
      Asize( aRet, x-1 )
   endif

   aTest := AClone(aRet)
   ASort( aTest,,, {|a,b| a[2] < b[2] } )
   ?
   ? 'Test Avg Result  Rank Method'
   ? '----+-----------+----+------'


   for i := 1 to Len(aRet)
      ? Str(i,3)+': '+Str( aRet[i][2]/(HRTEST_COUNT*v), 11, 9 )+' '+Str( AScan( aTest, {|e| e[1] == aRet[i][1] } ), 4 )+' '+aRet[i][3]
   next
   ?

   return

Function TestFunc0( c )
   local i

   for i := 1 to Len(c)
      c := Stuff( c, i, 1, SubStr(c,i,1) )
   next
   return 0

Function TestFunc0a( c )
   local i

   for i := 1 to Len(c)
      Stuff( @c, i, 1, SubStr(c,i,1) )
   next
   return 0


Function TestFunc1( c )
   local i

   for i := 1 to Len(c)
      c[i] := upper(c[i])
   next
   return 0

Function TestFunc2( c )
   local i
   local n := Len(c)

   for i := 1 to n
      c[i] := upper(c[i])
   next
   return 0


Function TestFunc3( c )
   local i
   local n := Len(c)
   local x

   for i := 1 to n
      x := Asc(c[i])
      x[6] := FALSE
      c[i] := Chr(x)
   next
   return 0


Function TestFunc4( c )
   local i
   local n := Len(c)
   local x

   for i := 1 to n
      if Asc(c[i]) > 0x60
         c[i] := Chr(Asc(c[i]) - BIT_MASK)
      endif
   next
   return 0

Function TestFunc5( c )
   local i
   local n := Len(c)
   local x

   for i := 1 to n
      if Asc(c[i]) > 0x60
         c[i] := upper(c[i])
      endif
   next
   return 0

Function TestFunc6( c )
   local i
   local n := Len(c)
   local x

   for i := 1 to n
      if !isUpper(c[i])
         c[i] := upper(c[i])
      endif
   next
   return 0


/*
Test Avg Result  Rank Method
----+-----------+----+------
  1: 0.006365664    8 TestFunc( cString2 )   Len(cString)
  2: 0.008192926   10 TestFunc( @cString2 )  Len(cString)
  3: 0.005146786    7 TestFunc2( cString2 )  asserted length
  4: 0.005129977    6 TestFunc2( @cString2 ) asserted length
  5: 0.011693694   11 TestFunc3( cString2 )  asserted length, bit-toggle 1
  6: 0.011756382   12 TestFunc3( @cString2 ) asserted length, bit-toggle 1
  7: 0.004676586    4 TestFunc4( cString2 )  asserted length, bit-toggle 2
  8: 0.002175669    1 TestFunc4( @cString2 ) asserted length, bit-toggle 2
  9: 0.003986078    3 TestFunc5( cString2 )  bit-toggle using bit-test
 10: 0.002301887    2 TestFunc5( @cString2 ) bit-toggle using bit-test
 11: 0.006677888    9 TestFunc6( cString2 )  bit-toggle using IsUpper()
 12: 0.005073819    5 TestFunc6( @cString2 ) bit-toggle using IsUpper()


*/




